#ifndef id9919CCB09DDD429C8128632F13D370ED
#define id9919CCB09DDD429C8128632F13D370ED

#include "scraplang_element.hpp"
#include <boost/spirit/include/support_extended_variant.hpp>
#include <string>
#include <vector>
#include <map>

namespace duck {
	struct ScrapNode;

	namespace implem {
		struct map;
		struct array;

		struct element : boost::spirit::extended_variant<
			boost::recursive_wrapper<map>,
			boost::recursive_wrapper<array>,
			std::string,
			int,
			double
		>
		{
			element ( void ) = default;
			element ( const map& parOther ) : base_type(parOther) {}
			element ( const array& parOther ) : base_type(parOther) {}
			element ( const std::string& parOther ) : base_type(parOther) {}
			element ( double parOther ) : base_type(parOther) {}
			element ( int parOther ) : base_type(parOther) {}
		};

		struct map : std::map<std::string, element> {
		};

		struct array : std::vector<element> {
		};

		struct node_list {
			std::vector<ScrapNode> nodes;
		};
	} //namespace implem

	struct ScrapNode : boost::spirit::extended_variant<
		element_def,
		implem::map,
		implem::node_list
	>
	{
		ScrapNode ( void ) = default;
		ScrapNode ( const element_def& parOther ) : base_type(parOther) {}
		ScrapNode ( const implem::map& parOther ) : base_type(parOther) {}
		ScrapNode ( const implem::node_list& parOther ) : base_type(parOther) {}
	};
} //namespace duck

#endif
