#ifndef id7648347E8EE84E65B69018880358C8DF
#define id7648347E8EE84E65B69018880358C8DF

#include "scrapast.hpp"
#include <vector>

namespace duck {
	namespace implem {
		class XPathVisitor {
		public:
			typedef void result_type;

			explicit XPathVisitor ( std::vector<element_def>* parElements );

			void operator() ( const element_def& parElem );
			void operator() ( const implem::map& parMap );
			void operator() ( const node_list& parNodes );

		private:
			std::vector<element_def>* const m_elements;
		};

		inline XPathVisitor::XPathVisitor (std::vector<element_def>* parElements) :
			m_elements(parElements)
		{
		}

		inline void XPathVisitor::operator() (const element_def& parElem) {
			m_elements->push_back(parElem);
		}

		inline void XPathVisitor::operator() (const implem::map&) {
			return;
		}

		inline void XPathVisitor::operator() (const node_list& parNodes) {
			for (const auto& node : parNodes.nodes) {
				boost::apply_visitor(*this, node);
			}
		}
	} //namespace implem
} //namespace duck

#endif
